diff --git a/common.h b/common.h
index f2062a9e9..1843e85a6 100644
--- a/common.h
+++ b/common.h
@@ -1092,4 +1092,8 @@ ZEND_BEGIN_ARG_INFO_EX(arginfo_georadiusbymember, 0, 0, 4)
     ZEND_ARG_ARRAY_INFO(0, opts, 0)
 ZEND_END_ARG_INFO()
 
+ZEND_BEGIN_ARG_INFO_EX(arginfo_flush, 0, 0, 0)
+    ZEND_ARG_INFO(0, async)
+ZEND_END_ARG_INFO()
+
 #endif
diff --git a/redis.c b/redis.c
index 7aaed838c..afbe7d865 100644
--- a/redis.c
+++ b/redis.c
@@ -267,8 +267,8 @@ static zend_function_entry redis_functions[] = {
      PHP_ME(Redis, exec, arginfo_void, ZEND_ACC_PUBLIC)
      PHP_ME(Redis, exists, arginfo_exists, ZEND_ACC_PUBLIC)
      PHP_ME(Redis, expireAt, arginfo_key_timestamp, ZEND_ACC_PUBLIC)
-     PHP_ME(Redis, flushAll, arginfo_void, ZEND_ACC_PUBLIC)
-     PHP_ME(Redis, flushDB, arginfo_void, ZEND_ACC_PUBLIC)
+     PHP_ME(Redis, flushAll, arginfo_flush, ZEND_ACC_PUBLIC)
+     PHP_ME(Redis, flushDB, arginfo_flush, ZEND_ACC_PUBLIC)
      PHP_ME(Redis, geoadd, arginfo_geoadd, ZEND_ACC_PUBLIC)
      PHP_ME(Redis, geodist, arginfo_geodist, ZEND_ACC_PUBLIC)
      PHP_ME(Redis, geohash, arginfo_key_members, ZEND_ACC_PUBLIC)
@@ -1736,17 +1736,17 @@ PHP_METHOD(Redis, lastSave)
 }
 /* }}} */
 
-/* {{{ proto bool Redis::flushDB() */
+/* {{{ proto bool Redis::flushDB([bool async]) */
 PHP_METHOD(Redis, flushDB)
 {
-    REDIS_PROCESS_KW_CMD("FLUSHDB", redis_empty_cmd, redis_boolean_response);
+    REDIS_PROCESS_KW_CMD("FLUSHDB", redis_flush_cmd, redis_boolean_response);
 }
 /* }}} */
 
-/* {{{ proto bool Redis::flushAll() */
+/* {{{ proto bool Redis::flushAll([bool async]) */
 PHP_METHOD(Redis, flushAll)
 {
-    REDIS_PROCESS_KW_CMD("FLUSHALL", redis_empty_cmd, redis_boolean_response);
+    REDIS_PROCESS_KW_CMD("FLUSHALL", redis_flush_cmd, redis_boolean_response);
 }
 /* }}} */
 
diff --git a/redis_commands.c b/redis_commands.c
index 629ec1058..739142e98 100644
--- a/redis_commands.c
+++ b/redis_commands.c
@@ -415,6 +415,24 @@ int redis_key_cmd(INTERNAL_FUNCTION_PARAMETERS, RedisSock *redis_sock,
     return SUCCESS;
 }
 
+int redis_flush_cmd(INTERNAL_FUNCTION_PARAMETERS, RedisSock *redis_sock,
+               char *kw, char **cmd, int *cmd_len, short *slot, void **ctx)
+{
+    zend_bool async = 0;
+
+    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "|b", &async) == FAILURE) {
+        return FAILURE;
+    }
+
+    if (async) {
+        *cmd_len = REDIS_CMD_SPPRINTF(cmd, kw, "s", "ASYNC", sizeof("ASYNC") - 1);
+    } else {
+        *cmd_len = REDIS_CMD_SPPRINTF(cmd, kw, "");
+    }
+
+    return SUCCESS;
+}
+
 /* Generic command where we take a key and a double */
 int redis_key_dbl_cmd(INTERNAL_FUNCTION_PARAMETERS, RedisSock *redis_sock,
                       char *kw, char **cmd, int *cmd_len, short *slot,
diff --git a/redis_commands.h b/redis_commands.h
index 978c10260..413b868e2 100644
--- a/redis_commands.h
+++ b/redis_commands.h
@@ -109,6 +109,9 @@ int redis_gen_zlex_cmd(INTERNAL_FUNCTION_PARAMETERS, RedisSock *redis_sock,
 int redis_eval_cmd(INTERNAL_FUNCTION_PARAMETERS, RedisSock *redis_sock,
     char *kw, char **cmd, int *cmd_len, short *slot, void **ctx);
 
+int redis_flush_cmd(INTERNAL_FUNCTION_PARAMETERS, RedisSock *redis_sock,
+    char *kw, char **cmd, int *cmd_len, short *slot, void **ctx);
+
 /* Commands which need a unique construction mechanism.  This is either because
  * they don't share a signature with any other command, or because there is 
  * specific processing we do (e.g. verifying subarguments) that make them
